image: "${CI_REGISTRY}/gitlab-com/gl-infra/ci-images/gitlab-com-infrastructure:latest"

stages:
  - verify
  - init
  - validate
  - check
  - plan
  - apply
  - notif
  - report

variables:
  TF_IN_AUTOMATION: 'true'
  TF_PLAN_FILE: "${CI_ENVIRONMENT_NAME}_${CI_COMMIT_REF_SLUG}.plan"

.send_event:
  before_script:
    -
      |
        # For logging events
        # https://gitlab.com/gitlab-com/runbooks/-/blob/master/docs/events/README.md
        sendEvent() {
          if [[ -z "$ES_NONPROD_EVENTS_URL" || $ES_EVENT_OVERRIDE == "true" ]]; then
            echo "Warning: Not sending events because ES_NONPROD_EVENTS_URL is not set or ES_EVENT_OVERRIDE is set to true"
            return
          fi
          command -v curl >/dev/null 2>&1 || \
            { echo >&2 "sending events requires curl but it's not installed."; return; }
          MSG="$1"
          ENV="$2"
          STAGE="${3:-main}"
          TS=$(date -u +%s000)
          USERNAME="${GITLAB_USER_LOGIN:-unknown}"
          SOURCE="${CI_PIPELINE_URL:-unknown}"
          DATA="
            {
              \"time\": \"$TS\",
              \"type\": \"configuration\",
              \"message\": \"$MSG\",
              \"env\": \"$ENV\",
              \"username\": \"$USERNAME\",
              \"source\": \"$SOURCE\",
              \"stage\": \"$STAGE\"
            }
          "
          echo "Sending event: \"$MSG\""
          curl -s -X POST \
            --retry 5 \
            --retry-max-time 20 \
            "$ES_NONPROD_EVENTS_URL/events-$ENV/_doc" -H 'Content-Type: application/json' -d "$DATA" > /dev/null
        }

change-lock:
  image: "${CI_REGISTRY}/gitlab-com/gl-infra/change-lock:latest"
  stage: verify
  script:
    - change-lock --tags infra --slack-channels=#infrastructure-lounge
  only:
    refs:
      - merge_requests

tf_format:
  stage: verify
  script: |
    echo "running tf format"  # there's no output for empty builds otherwise
    terraform fmt  -recursive -check .
  only:
    refs:
      - merge_requests

shellcheck:
  stage: verify
  image: 'koalaman/shellcheck-alpine'
  script: shellcheck --source-path=bin/ bin/*
  only:
    refs:
      - merge_requests

shfmt:
  stage: verify
  image:
    name: 'mvdan/shfmt:v3.0.0'
    entrypoint: [""]
  script: shfmt -i 2 -ci -d bin/
  only:
    refs:
      - merge_requests

danger_review:
  stage: verify
  image: "${CI_REGISTRY}/gitlab-org/gitlab-build-images:danger"
  except:
    - tags
    - master
  script:
    # The `DANGER_GITLAB_API_TOKEN` token is saved under the DevOps 1password vault,
    # under "Danger bot - OPS" name. The private token has been added to
    # https://ops.gitlab.net/groups/gitlab-com and it has API scope set.
    - danger --fail-on-errors=true
  only:
    refs:
      - merge_requests

.pre_scripts: &pre_scripts
  before_script:
    - for version in $(find . -name .terraform-version |xargs cat |sort -u); do /.tfenv/bin/tfenv install ${version}; done

.tf_init_scripts: &tf_init_scripts
  script: |
    eval $(ssh-agent -s)
    echo "$SSH_PRIVATE_KEY" | base64 -d | tr -d '\r' | ssh-add - > /dev/null
    mkdir -p ~/.ssh
    chmod 700 ~/.ssh
    echo "$SSH_KNOWN_HOSTS" > ~/.ssh/known_hosts
    chmod 644 ~/.ssh/known_hosts

    echo "Set up gcloud..."
    if [ -f "$GCLOUD_TERRAFORM_PRIVATE_KEY_JSON" ]; then gcloud auth activate-service-account --key-file $GCLOUD_TERRAFORM_PRIVATE_KEY_JSON; fi
    echo "Initializing working directory for ${CI_ENVIRONMENT_NAME}..."
    cd environments/${CI_ENVIRONMENT_NAME}
    terraform init
  artifacts:
    paths:
      - environments/${CI_ENVIRONMENT_NAME}/.terraform

.tf_plan_scripts: &tf_plan_scripts
  script:
    - export GOOGLE_CLOUD_KEYFILE_JSON=${GCLOUD_TERRAFORM_PRIVATE_KEY_JSON}
    - cd environments/$CI_ENVIRONMENT_NAME
    - terraform plan -input=false -out=${TF_PLAN_FILE}
  artifacts:
    paths:
      - environments/${CI_ENVIRONMENT_NAME}/${TF_PLAN_FILE}

.tf_init: &tf_init
  stage: init
  except:
    - schedules
  <<: *pre_scripts
  <<: *tf_init_scripts

.tf_validate: &tf_validate
  stage: validate
  script:
    - echo "running terraform validate for ${CI_ENVIRONMENT_NAME}"  # there's no output for empty builds otherwise
    - cd environments/$CI_ENVIRONMENT_NAME
    - terraform validate
    - tflint
  except:
    - schedules
  <<: *pre_scripts

.review_plan: &review_plan
  script:
    - export GOOGLE_CLOUD_KEYFILE_JSON=${GCLOUD_TERRAFORM_PRIVATE_KEY_JSON}
    - cd environments/$CI_ENVIRONMENT_NAME
    - terraform plan -out=${TF_PLAN_FILE} -input=false

    # Allow GitLab to show plans
    # As described in https://docs.gitlab.com/ee/user/infrastructure/mr_integration.html#multiple-terraform-plan-reports
    - terraform show --json ${TF_PLAN_FILE} | jq -r '([.resource_changes[]?.change.actions?]|flatten)|{"create":(map(select(.=="create"))|length),"update":(map(select(.=="update"))|length),"delete":(map(select(.=="delete"))|length)}' > tfplan.json
  except:
    - schedules
  artifacts:
    reports:
      terraform: environments/$CI_ENVIRONMENT_NAME/tfplan.json
  <<: *pre_scripts

.merge_plan: &merge_plan
  except:
    - schedules
  <<: *pre_scripts
  <<: *tf_plan_scripts

.tf_apply: &tf_apply
  script: |
    # Terraform plan
    export GOOGLE_CLOUD_KEYFILE_JSON=${GCLOUD_TERRAFORM_PRIVATE_KEY_JSON}
    echo "Set up gcloud..."
    if [ -f "$GCLOUD_TERRAFORM_PRIVATE_KEY_JSON" ]; then gcloud auth activate-service-account --key-file $GCLOUD_TERRAFORM_PRIVATE_KEY_JSON; fi
    cd environments/$CI_ENVIRONMENT_NAME
    terraform apply -input=false ${TF_PLAN_FILE}
  except:
    - schedules
  <<: *pre_scripts


# Generate metrics from `terraform show` and push to a Prometheus pushgateway
# Required until https://gitlab.com/gitlab-com/gl-infra/infrastructure/-/issues/13179 is delivered
.tf_report: &tf_report
  stage: report
  script: |
    # Terraform report
    export GOOGLE_CLOUD_KEYFILE_JSON=${GCLOUD_TERRAFORM_PRIVATE_KEY_JSON}
    echo "Set up gcloud..."
    if [ -f "$GCLOUD_TERRAFORM_PRIVATE_KEY_JSON" ]; then gcloud auth activate-service-account --key-file $GCLOUD_TERRAFORM_PRIVATE_KEY_JSON; fi
    cd environments/$CI_ENVIRONMENT_NAME
    bash ../../bin/tf-report-prometheus-pushgateway
  tags:
    - k8s-workloads
  except:
    - schedules
  <<: *pre_scripts

##################################################
# aws-account
##################################################
init aws-account:
  environment: aws-account
  only:
    refs:
      - merge_requests
      - master
    changes:
      - .gitlab-ci.yml
      - environments/aws-account/*
  <<: *tf_init

validate aws-account:
  dependencies: ["init aws-account"]
  environment:
    name: aws-account
  needs: ["init aws-account"]
  only:
    refs:
      - merge_requests
      - master
    changes:
      - .gitlab-ci.yml
      - environments/aws-account/**
  <<: *tf_validate

review aws-account:
  stage: plan
  dependencies: ["init aws-account"]
  environment:
    name: aws-account
  needs:
    - init aws-account
    - validate aws-account
  only:
    refs:
      - merge_requests
    changes:
      - .gitlab-ci.yml
      - environments/aws-account/**
  <<: *review_plan

plan aws-account:
  stage: plan
  dependencies: ["init aws-account"]
  environment:
    name: aws-account
  needs:
    - init aws-account
    - validate aws-account
  only:
    changes:
      - .gitlab-ci.yml
      - environments/aws-account/**
    refs:
      - master
  <<: *merge_plan

apply aws-account:
  stage: apply
  dependencies:
    - init aws-account
    - plan aws-account
  environment:
    name: aws-account
  needs:
    - init aws-account
    - plan aws-account
  only:
    refs:
      - master
    changes:
      - .gitlab-ci.yml
      - environments/aws-account/**
  when: manual
  <<: *tf_apply

##################################################
# aws-snowplow
##################################################

.snowplow-change-patterns: &snowplow-change-pattern
  - .gitlab-ci.yml
  - environments/aws-snowplow/*
  - environments/aws-snowplow/**/*

init aws-snowplow:
  environment: aws-snowplow
  only:
    refs:
      - merge_requests
      - master
    changes: *snowplow-change-pattern
  <<: *tf_init

validate aws-snowplow:
  dependencies: ["init aws-snowplow"]
  environment:
    name: aws-snowplow
  needs: ["init aws-snowplow"]
  only:
    refs:
      - merge_requests
      - master
    changes: *snowplow-change-pattern
  <<: *tf_validate

review aws-snowplow:
  stage: plan
  dependencies: ["init aws-snowplow"]
  environment:
    name: aws-snowplow
  needs:
    - init aws-snowplow
    - validate aws-snowplow
  only:
    refs:
      - merge_requests
    changes: *snowplow-change-pattern
  <<: *review_plan

plan aws-snowplow:
  stage: plan
  dependencies: ["init aws-snowplow"]
  environment:
    name: aws-snowplow
  needs:
    - init aws-snowplow
    - validate aws-snowplow
  only:
    changes: *snowplow-change-pattern
    refs:
      - master
  <<: *merge_plan

apply aws-snowplow:
  stage: apply
  dependencies:
    - init aws-snowplow
    - plan aws-snowplow
  environment:
    name: aws-snowplow
  needs:
    - init aws-snowplow
    - plan aws-snowplow
  only:
    refs:
      - master
    changes: *snowplow-change-pattern
  when: manual
  <<: *tf_apply

##################################################
# dr
##################################################
# init dr:
#   environment: dr
#   only:
#     refs:
#       - merge_requests
#       - master
#     changes:
#       - .gitlab-ci.yml
#       - environments/dr/*
#   <<: *tf_init

# validate dr:
#   dependencies: ["init dr"]
#   environment:
#     name: dr
#   needs: ["init dr"]
#   only:
#     refs:
#       - merge_requests
#       - master
#     changes:
#       - .gitlab-ci.yml
#       - environments/dr/**
#   <<: *tf_validate

# review dr:
#   stage: plan
#   dependencies: ["init dr"]
#   environment:
#     name: dr
#   needs:
#     - init dr
#     - validate dr
#   only:
#     refs:
#       - merge_requests
#     changes:
#       - .gitlab-ci.yml
#       - environments/dr/**
#   <<: *review_plan

# plan dr:
#   stage: plan
#   dependencies: ["init dr"]
#   environment:
#     name: dr
#   needs:
#     - init dr
#     - validate dr
#   only:
#     changes:
#       - .gitlab-ci.yml
#       - environments/dr/**
#     refs:
#       - master
#   <<: *merge_plan

# apply dr:
#   stage: apply
#   dependencies:
#     - init dr
#     - plan dr
#   environment:
#     name: dr
#   needs:
#     - init dr
#     - plan dr
#   only:
#     refs:
#       - master
#     changes:
#       - .gitlab-ci.yml
#       - environments/dr/**
#   when: manual
#   <<: *tf_apply

##################################################
# gprd
##################################################
init gprd:
  environment: gprd
  only:
    refs:
      - merge_requests
      - master
    changes:
      - .gitlab-ci.yml
      - environments/gprd/*
      - modules/gke-reservations/*
  <<: *tf_init

validate gprd:
  dependencies: ["init gprd"]
  environment:
    name: gprd
  needs: ["init gprd"]
  only:
    refs:
      - merge_requests
      - master
    changes:
      - .gitlab-ci.yml
      - environments/gprd/**
      - modules/gke-reservations/*
  <<: *tf_validate

review gprd:
  stage: plan
  dependencies: ["init gprd"]
  environment:
    name: gprd
  needs:
    - init gprd
    - validate gprd
  only:
    refs:
      - merge_requests
    changes:
      - .gitlab-ci.yml
      - environments/gprd/**
      - modules/gke-reservations/*
  <<: *review_plan

plan gprd:
  stage: plan
  dependencies: ["init gprd"]
  environment:
    name: gprd
  needs:
    - init gprd
    - validate gprd
  only:
    changes:
      - .gitlab-ci.yml
      - environments/gprd/**
      - modules/gke-reservations/*
    refs:
      - master
  <<: *merge_plan

apply gprd:
  stage: apply
  dependencies:
    - init gprd
    - plan gprd
  environment:
    name: gprd
  needs:
    - init gprd
    - plan gprd
  only:
    refs:
      - master
    changes:
      - .gitlab-ci.yml
      - environments/gprd/**
      - modules/gke-reservations/*
  when: manual
  <<: *tf_apply

# Generate metrics from `terraform show` and push to a Prometheus pushgateway
# Required until https://gitlab.com/gitlab-com/gl-infra/infrastructure/-/issues/13179 is delivered
report gprd:
  stage: report
  dependencies:
    - init gprd
  environment:
    name: gprd
  only:
    refs:
      - master
    changes:
      - .gitlab-ci.yml
      - environments/gprd/*
      - modules/gke-reservations/*
  <<: *tf_report

event notif gprd:
  # This job automatically runs because most applys are done outside of CI
  extends: .send_event
  stage: apply
  dependencies:
    - init gprd
    - plan gprd
  environment:
    name: gprd
  needs:
    - init gprd
    - plan gprd
  only:
    refs:
      - master
    changes:
      - .gitlab-ci.yml
      - environments/gprd/**
      - modules/gke-reservations/*
  except:
    - schedules
  script:
    - sendEvent "Terraform configuration changed" "gprd"

##################################################
# gprd-scheduled
##################################################

init gprd-scheduled:
  stage: init
  environment: gprd
  only:
    - schedules
  <<: *pre_scripts
  <<: *tf_init_scripts

# check for broken master
plan-check-clean gprd-scheduled:
  stage: check
  dependencies: ["init gprd-scheduled"]
  environment:
    name: gprd
  only:
    - schedules
  script:
    - export GOOGLE_CLOUD_KEYFILE_JSON=${GCLOUD_TERRAFORM_PRIVATE_KEY_JSON}
    - cd environments/$CI_ENVIRONMENT_NAME
    - terraform plan -input=false -detailed-exitcode
  <<: *pre_scripts

# this job is manual in order to avoid running concurrently with plan-check-clean
# as that pushes us over the GCP API quota (read calls per 100 seconds)
plan gprd-scheduled:
  stage: plan
  dependencies: ["init gprd-scheduled"]
  environment:
    name: gprd
  only:
    - schedules
  when: manual
  <<: *pre_scripts
  <<: *tf_plan_scripts

# manual job to squash unclean diff
apply gprd-scheduled:
  stage: apply
  dependencies:
    - init gprd-scheduled
    - plan gprd-scheduled
  environment:
    name: gprd
  needs:
    - init gprd-scheduled
    - plan gprd-scheduled
  only:
    - schedules
  when: manual
  script: |
    # Terraform plan
    export GOOGLE_CLOUD_KEYFILE_JSON=${GCLOUD_TERRAFORM_PRIVATE_KEY_JSON}
    echo "Set up gcloud..."
    if [ -f "$GCLOUD_TERRAFORM_PRIVATE_KEY_JSON" ]; then gcloud auth activate-service-account --key-file $GCLOUD_TERRAFORM_PRIVATE_KEY_JSON; fi
    cd environments/$CI_ENVIRONMENT_NAME
    terraform apply -input=false ${TF_PLAN_FILE}
  <<: *pre_scripts

event notif gprd-scheduled:
  extends: .send_event
  stage: notif
  dependencies:
    - init gprd-scheduled
    - plan gprd-scheduled
    - apply gprd-scheduled
  environment:
    name: gprd
  needs:
    - init gprd-scheduled
    - plan gprd-scheduled
    - apply gprd-scheduled
  only:
    - schedules
  script:
    - sendEvent "Terraform configuration changed" "gprd"

##################################################
# gstg
##################################################
init gstg:
  environment: gstg
  only:
    refs:
      - merge_requests
      - master
    changes:
      - .gitlab-ci.yml
      - environments/gstg/*
      - modules/gke-reservations/*
  <<: *tf_init

validate gstg:
  dependencies: ["init gstg"]
  environment:
    name: gstg
  needs: ["init gstg"]
  only:
    refs:
      - merge_requests
      - master
    changes:
      - .gitlab-ci.yml
      - environments/gstg/**
      - modules/gke-reservations/*
  <<: *tf_validate

review gstg:
  stage: plan
  dependencies: ["init gstg"]
  environment:
    name: gstg
  needs:
    - init gstg
    - validate gstg
  only:
    refs:
      - merge_requests
    changes:
      - .gitlab-ci.yml
      - environments/gstg/**
      - modules/gke-reservations/*
  <<: *review_plan

plan gstg:
  stage: plan
  dependencies: ["init gstg"]
  environment:
    name: gstg
  needs:
    - init gstg
    - validate gstg
  only:
    changes:
      - .gitlab-ci.yml
      - environments/gstg/**
      - modules/gke-reservations/*
    refs:
      - master
  <<: *merge_plan

apply gstg:
  stage: apply
  dependencies:
    - init gstg
    - plan gstg
  environment:
    name: gstg
  needs:
    - init gstg
    - plan gstg
  only:
    refs:
      - master
    changes:
      - .gitlab-ci.yml
      - environments/gstg/**
      - modules/gke-reservations/*
  when: manual
  <<: *tf_apply

##################################################
# gstg-scheduled
##################################################

init gstg-scheduled:
  stage: init
  environment: gstg
  only:
    - schedules
  <<: *pre_scripts
  <<: *tf_init_scripts

# check for broken master
plan-check-clean gstg-scheduled:
  stage: check
  dependencies: ["init gstg-scheduled"]
  environment:
    name: gstg
  only:
    - schedules
  script:
    - export GOOGLE_CLOUD_KEYFILE_JSON=${GCLOUD_TERRAFORM_PRIVATE_KEY_JSON}
    - cd environments/$CI_ENVIRONMENT_NAME
    - terraform plan -input=false -detailed-exitcode
  <<: *pre_scripts

# this job is manual in order to avoid running concurrently with plan-check-clean
# as that pushes us over the GCP API quota (read calls per 100 seconds)
plan gstg-scheduled:
  stage: plan
  dependencies: ["init gstg-scheduled"]
  environment:
    name: gstg
  only:
    - schedules
  when: manual
  <<: *pre_scripts
  <<: *tf_plan_scripts

# manual job to squash unclean diff
apply gstg-scheduled:
  stage: apply
  dependencies:
    - init gstg-scheduled
    - plan gstg-scheduled
  environment:
    name: gstg
  needs:
    - init gstg-scheduled
    - plan gstg-scheduled
  only:
    - schedules
  when: manual
  script: |
    # Terraform plan
    export GOOGLE_CLOUD_KEYFILE_JSON=${GCLOUD_TERRAFORM_PRIVATE_KEY_JSON}
    echo "Set up gcloud..."
    if [ -f "$GCLOUD_TERRAFORM_PRIVATE_KEY_JSON" ]; then gcloud auth activate-service-account --key-file $GCLOUD_TERRAFORM_PRIVATE_KEY_JSON; fi
    cd environments/$CI_ENVIRONMENT_NAME
    terraform apply -input=false ${TF_PLAN_FILE}
  <<: *pre_scripts

event notif gstg-scheduled:
  extends: .send_event
  stage: notif
  dependencies:
    - init gstg-scheduled
    - plan gstg-scheduled
    - apply gstg-scheduled
  environment:
    name: gstg
  needs:
    - init gstg-scheduled
    - plan gstg-scheduled
    - apply gstg-scheduled
  only:
    - schedules
  script:
    - sendEvent "Terraform configuration changed" "gstg"

# Generate metrics from `terraform show` and push to a Prometheus pushgateway
# Required until https://gitlab.com/gitlab-com/gl-infra/infrastructure/-/issues/13179 is delivered
report gstg:
  stage: report
  dependencies:
    - init gstg
  environment:
    name: gstg
  only:
    refs:
      - master
    changes:
      - .gitlab-ci.yml
      - environments/gstg/*
      - modules/gke-reservations/*
  <<: *tf_report

event notif gstg:
  # This job automatically runs because most applys are done outside of CI
  extends: .send_event
  stage: apply
  dependencies:
    - init gstg
    - plan gstg
  environment:
    name: gstg
  needs:
    - init gstg
    - plan gstg
  only:
    refs:
      - master
    changes:
      - .gitlab-ci.yml
      - environments/gstg/**
      - modules/gke-reservations/*
  except:
    - schedules
  script:
    - sendEvent "Terraform configuration changed" "gstg"

##################################################
# ops
##################################################
init ops:
  environment: ops
  only:
    refs:
      - merge_requests
      - master
    changes:
      - .gitlab-ci.yml
      - environments/ops/*
  <<: *tf_init

validate ops:
  dependencies: ["init ops"]
  environment:
    name: ops
  needs: ["init ops"]
  only:
    refs:
      - merge_requests
      - master
    changes:
      - .gitlab-ci.yml
      - environments/ops/**
  <<: *tf_validate

review ops:
  stage: plan
  dependencies: ["init ops"]
  environment:
    name: ops
  needs:
    - init ops
    - validate ops
  only:
    refs:
      - merge_requests
    changes:
      - .gitlab-ci.yml
      - environments/ops/**
  <<: *review_plan

plan ops:
  stage: plan
  dependencies: ["init ops"]
  environment:
    name: ops
  needs:
    - init ops
    - validate ops
  only:
    changes:
      - .gitlab-ci.yml
      - environments/ops/**
    refs:
      - master
  <<: *merge_plan

apply ops:
  stage: apply
  dependencies:
    - init ops
    - plan ops
  environment:
    name: ops
  needs:
    - init ops
    - plan ops
  only:
    refs:
      - master
    changes:
      - .gitlab-ci.yml
      - environments/ops/**
  when: manual
  <<: *tf_apply

##################################################
# pre
##################################################
init pre:
  environment: pre
  only:
    refs:
      - merge_requests
      - master
    changes:
      - .gitlab-ci.yml
      - environments/pre/*
      - modules/gke-reservations/*
  <<: *tf_init

validate pre:
  dependencies: ["init pre"]
  environment:
    name: pre
  needs: ["init pre"]
  only:
    refs:
      - merge_requests
      - master
    changes:
      - .gitlab-ci.yml
      - environments/pre/**
      - modules/gke-reservations/*
  <<: *tf_validate

review pre:
  stage: plan
  dependencies: ["init pre"]
  environment:
    name: pre
  needs:
    - init pre
    - validate pre
  only:
    refs:
      - merge_requests
    changes:
      - .gitlab-ci.yml
      - environments/pre/**
      - modules/gke-reservations/*
  <<: *review_plan

plan pre:
  stage: plan
  dependencies: ["init pre"]
  environment:
    name: pre
  needs:
    - init pre
    - validate pre
  only:
    changes:
      - .gitlab-ci.yml
      - environments/pre/**
      - modules/gke-reservations/*
    refs:
      - master
  <<: *merge_plan

apply pre:
  stage: apply
  dependencies:
    - init pre
    - plan pre
  environment:
    name: pre
  needs:
    - init pre
    - plan pre
  only:
    refs:
      - master
    changes:
      - .gitlab-ci.yml
      - environments/pre/**
      - modules/gke-reservations/*
  when: manual
  <<: *tf_apply

# Generate metrics from `terraform show` and push to a Prometheus pushgateway
# Required until https://gitlab.com/gitlab-com/gl-infra/infrastructure/-/issues/13179 is delivered
report pre:
  stage: report
  dependencies:
    - init pre
  environment:
    name: pre
  only:
    refs:
      - master
    changes:
      - .gitlab-ci.yml
      - environments/pre/*
      - modules/gke-reservations/*
  <<: *tf_report

##################################################
# release
##################################################
init release:
  environment: release
  only:
    refs:
      - merge_requests
      - master
    changes:
      - .gitlab-ci.yml
      - environments/release/*
  <<: *tf_init

validate release:
  dependencies: ["init release"]
  environment:
    name: release
  needs: ["init release"]
  only:
    refs:
      - merge_requests
      - master
    changes:
      - .gitlab-ci.yml
      - environments/release/**
  <<: *tf_validate

review release:
  stage: plan
  dependencies: ["init release"]
  environment:
    name: release
  needs:
    - init release
    - validate release
  only:
    refs:
      - merge_requests
    changes:
      - .gitlab-ci.yml
      - environments/release/**
  <<: *review_plan

plan release:
  stage: plan
  dependencies: ["init release"]
  environment:
    name: release
  needs:
    - init release
    - validate release
  only:
    changes:
      - .gitlab-ci.yml
      - environments/release/**
    refs:
      - master
  <<: *merge_plan

apply release:
  stage: apply
  dependencies:
    - init release
    - plan release
  environment:
    name: release
  needs:
    - init release
    - plan release
  only:
    refs:
      - master
    changes:
      - .gitlab-ci.yml
      - environments/release/**
  when: manual
  <<: *tf_apply

##################################################
# testbed
##################################################
init testbed:
  environment: testbed
  only:
    refs:
      - merge_requests
      - master
    changes:
      - .gitlab-ci.yml
      - environments/testbed/*
  <<: *tf_init

validate testbed:
  dependencies: ["init testbed"]
  environment:
    name: testbed
  needs: ["init testbed"]
  only:
    refs:
      - merge_requests
      - master
    changes:
      - .gitlab-ci.yml
      - environments/testbed/**
  <<: *tf_validate

review testbed:
  stage: plan
  dependencies: ["init testbed"]
  environment:
    name: testbed
  needs:
    - init testbed
    - validate testbed
  only:
    refs:
      - merge_requests
    changes:
      - .gitlab-ci.yml
      - environments/testbed/**
  <<: *review_plan

plan testbed:
  stage: plan
  dependencies: ["init testbed"]
  environment:
    name: testbed
  needs:
    - init testbed
    - validate testbed
  only:
    changes:
      - .gitlab-ci.yml
      - environments/testbed/**
    refs:
      - master
  <<: *merge_plan

apply testbed:
  stage: apply
  dependencies:
    - init testbed
    - plan testbed
  environment:
    name: testbed
  needs:
    - init testbed
    - plan testbed
  only:
    refs:
      - master
    changes:
      - .gitlab-ci.yml
      - environments/testbed/**
  when: manual
  <<: *tf_apply

##################################################
# redirects
##################################################
init redirects:
  environment: redirects
  only:
    refs:
      - merge_requests
      - master
    changes:
      - .gitlab-ci.yml
      - environments/redirects/*
  <<: *tf_init

validate redirects:
  dependencies: ["init redirects"]
  environment:
    name: redirects
  needs: ["init redirects"]
  only:
    refs:
      - merge_requests
      - master
    changes:
      - .gitlab-ci.yml
      - environments/redirects/**
  <<: *tf_validate

review redirects:
  stage: plan
  dependencies: ["init redirects"]
  environment:
    name: redirects
  needs:
    - init redirects
    - validate redirects
  only:
    refs:
      - merge_requests
    changes:
      - .gitlab-ci.yml
      - environments/redirects/**
  <<: *review_plan

plan redirects:
  stage: plan
  dependencies: ["init redirects"]
  environment:
    name: redirects
  needs:
    - init redirects
    - validate redirects
  only:
    changes:
      - .gitlab-ci.yml
      - environments/redirects/**
    refs:
      - master
  <<: *merge_plan

apply redirects:
  stage: apply
  dependencies:
    - init redirects
    - plan redirects
  environment:
    name: redirects
  needs:
    - init redirects
    - plan redirects
  only:
    refs:
      - master
    changes:
      - .gitlab-ci.yml
      - environments/redirects/**
  when: manual
  <<: *tf_apply

##################################################
# ci
##################################################
init ci:
  environment: ci
  only:
    refs:
      - merge_requests
      - master
    changes:
      - .gitlab-ci.yml
      - environments/ci/*
  <<: *tf_init

validate ci:
  dependencies: ["init ci"]
  environment:
    name: ci
  needs: ["init ci"]
  only:
    refs:
      - merge_requests
      - master
    changes:
      - .gitlab-ci.yml
      - environments/ci/**
  <<: *tf_validate

review ci:
  stage: plan
  dependencies: ["init ci"]
  environment:
    name: ci
  needs:
    - init ci
    - validate ci
  only:
    refs:
      - merge_requests
    changes:
      - .gitlab-ci.yml
      - environments/ci/**
  <<: *review_plan

plan ci:
  stage: plan
  dependencies: ["init ci"]
  environment:
    name: ci
  needs:
    - init ci
    - validate ci
  only:
    changes:
      - .gitlab-ci.yml
      - environments/ci/**
    refs:
      - master
  <<: *merge_plan

apply ci:
  stage: apply
  dependencies:
    - init ci
    - plan ci
  environment:
    name: ci
  needs:
    - init ci
    - plan ci
  only:
    refs:
      - master
    changes:
      - .gitlab-ci.yml
      - environments/ci/**
  when: manual
  <<: *tf_apply

##################################################
# org-ci
##################################################
init org-ci:
  environment: org-ci
  only:
    refs:
      - merge_requests
      - master
    changes:
      - .gitlab-ci.yml
      - environments/org-ci/*
  <<: *tf_init

validate org-ci:
  dependencies: ["init org-ci"]
  environment:
    name: org-ci
  needs: ["init org-ci"]
  only:
    refs:
      - merge_requests
      - master
    changes:
      - .gitlab-ci.yml
      - environments/org-ci/**
  <<: *tf_validate

review org-ci:
  stage: plan
  dependencies: ["init org-ci"]
  environment:
    name: org-ci
  needs:
    - init org-ci
    - validate org-ci
  only:
    refs:
      - merge_requests
    changes:
      - .gitlab-ci.yml
      - environments/org-ci/**
  <<: *review_plan

plan org-ci:
  stage: plan
  dependencies: ["init org-ci"]
  environment:
    name: org-ci
  needs:
    - init org-ci
    - validate org-ci
  only:
    changes:
      - .gitlab-ci.yml
      - environments/org-ci/**
    refs:
      - master
  <<: *merge_plan

apply org-ci:
  stage: apply
  dependencies:
    - init org-ci
    - plan org-ci
  environment:
    name: org-ci
  needs:
    - init org-ci
    - plan org-ci
  only:
    refs:
      - master
    changes:
      - .gitlab-ci.yml
      - environments/org-ci/**
  when: manual
  <<: *tf_apply

##################################################
# ci-plan-free-3
##################################################
init ci-plan-free-3:
  environment: ci-plan-free-3
  only:
    refs:
    - merge_requests
    - master
    changes:
    - .gitlab-ci.yml
    - environments/ci-plan-free-3/**
    - modules/runner-manager-ephemeral-vms-project/**
  <<: *tf_init

validate ci-plan-free-3:
  dependencies: ["init ci-plan-free-3"]
  environment:
    name: ci-plan-free-3
  needs: ["init ci-plan-free-3"]
  only:
    refs:
    - merge_requests
    - master
    changes:
    - .gitlab-ci.yml
    - environments/ci-plan-free-3/**
    - modules/runner-manager-ephemeral-vms-project/**
  <<: *tf_validate

review ci-plan-free-3:
  stage: plan
  dependencies: ["init ci-plan-free-3"]
  environment:
    name: ci-plan-free-3
  needs:
  - init ci-plan-free-3
  - validate ci-plan-free-3
  only:
    refs:
    - merge_requests
    changes:
    - .gitlab-ci.yml
    - environments/ci-plan-free-3/**
    - modules/runner-manager-ephemeral-vms-project/**
  <<: *review_plan

plan ci-plan-free-3:
  stage: plan
  dependencies: ["init ci-plan-free-3"]
  environment:
    name: ci-plan-free-3
  needs:
  - init ci-plan-free-3
  - validate ci-plan-free-3
  only:
    changes:
    - .gitlab-ci.yml
    - environments/ci-plan-free-3/**
    - modules/runner-manager-ephemeral-vms-project/**
    refs:
    - master
  <<: *merge_plan

apply ci-plan-free-3:
  stage: apply
  dependencies:
  - init ci-plan-free-3
  - plan ci-plan-free-3
  environment:
    name: ci-plan-free-3
  needs:
  - init ci-plan-free-3
  - plan ci-plan-free-3
  only:
    refs:
    - master
    changes:
    - .gitlab-ci.yml
    - environments/ci-plan-free-3/**
    - modules/runner-manager-ephemeral-vms-project/**
  when: manual
  <<: *tf_apply

##################################################
# ci-plan-free-4
##################################################
init ci-plan-free-4:
  environment: ci-plan-free-4
  only:
    refs:
    - merge_requests
    - master
    changes:
    - .gitlab-ci.yml
    - environments/ci-plan-free-4/**
    - modules/runner-manager-ephemeral-vms-project/**
  <<: *tf_init

validate ci-plan-free-4:
  dependencies: ["init ci-plan-free-4"]
  environment:
    name: ci-plan-free-4
  needs: ["init ci-plan-free-4"]
  only:
    refs:
    - merge_requests
    - master
    changes:
    - .gitlab-ci.yml
    - environments/ci-plan-free-4/**
    - modules/runner-manager-ephemeral-vms-project/**
  <<: *tf_validate

review ci-plan-free-4:
  stage: plan
  dependencies: ["init ci-plan-free-4"]
  environment:
    name: ci-plan-free-4
  needs:
  - init ci-plan-free-4
  - validate ci-plan-free-4
  only:
    refs:
    - merge_requests
    changes:
    - .gitlab-ci.yml
    - environments/ci-plan-free-4/**
    - modules/runner-manager-ephemeral-vms-project/**
  <<: *review_plan

plan ci-plan-free-4:
  stage: plan
  dependencies: ["init ci-plan-free-4"]
  environment:
    name: ci-plan-free-4
  needs:
  - init ci-plan-free-4
  - validate ci-plan-free-4
  only:
    changes:
    - .gitlab-ci.yml
    - environments/ci-plan-free-4/**
    - modules/runner-manager-ephemeral-vms-project/**
    refs:
    - master
  <<: *merge_plan

apply ci-plan-free-4:
  stage: apply
  dependencies:
  - init ci-plan-free-4
  - plan ci-plan-free-4
  environment:
    name: ci-plan-free-4
  needs:
  - init ci-plan-free-4
  - plan ci-plan-free-4
  only:
    refs:
    - master
    changes:
    - .gitlab-ci.yml
    - environments/ci-plan-free-4/**
    - modules/runner-manager-ephemeral-vms-project/**
  when: manual
  <<: *tf_apply

##################################################
# ci-plan-free-5
##################################################
init ci-plan-free-5:
  environment: ci-plan-free-5
  only:
    refs:
    - merge_requests
    - master
    changes:
    - .gitlab-ci.yml
    - environments/ci-plan-free-5/**
    - modules/runner-manager-ephemeral-vms-project/**
  <<: *tf_init

validate ci-plan-free-5:
  dependencies: ["init ci-plan-free-5"]
  environment:
    name: ci-plan-free-5
  needs: ["init ci-plan-free-5"]
  only:
    refs:
    - merge_requests
    - master
    changes:
    - .gitlab-ci.yml
    - environments/ci-plan-free-5/**
    - modules/runner-manager-ephemeral-vms-project/**
  <<: *tf_validate

review ci-plan-free-5:
  stage: plan
  dependencies: ["init ci-plan-free-5"]
  environment:
    name: ci-plan-free-5
  needs:
  - init ci-plan-free-5
  - validate ci-plan-free-5
  only:
    refs:
    - merge_requests
    changes:
    - .gitlab-ci.yml
    - environments/ci-plan-free-5/**
    - modules/runner-manager-ephemeral-vms-project/**
  <<: *review_plan

plan ci-plan-free-5:
  stage: plan
  dependencies: ["init ci-plan-free-5"]
  environment:
    name: ci-plan-free-5
  needs:
  - init ci-plan-free-5
  - validate ci-plan-free-5
  only:
    changes:
    - .gitlab-ci.yml
    - environments/ci-plan-free-5/**
    - modules/runner-manager-ephemeral-vms-project/**
    refs:
    - master
  <<: *merge_plan

apply ci-plan-free-5:
  stage: apply
  dependencies:
  - init ci-plan-free-5
  - plan ci-plan-free-5
  environment:
    name: ci-plan-free-5
  needs:
  - init ci-plan-free-5
  - plan ci-plan-free-5
  only:
    refs:
    - master
    changes:
    - .gitlab-ci.yml
    - environments/ci-plan-free-5/**
    - modules/runner-manager-ephemeral-vms-project/**
  when: manual
  <<: *tf_apply

##################################################
# ci-plan-free-6
##################################################
init ci-plan-free-6:
  environment: ci-plan-free-6
  only:
    refs:
    - merge_requests
    - master
    changes:
    - .gitlab-ci.yml
    - environments/ci-plan-free-6/**
    - modules/runner-manager-ephemeral-vms-project/**
  <<: *tf_init

validate ci-plan-free-6:
  dependencies: ["init ci-plan-free-6"]
  environment:
    name: ci-plan-free-6
  needs: ["init ci-plan-free-6"]
  only:
    refs:
    - merge_requests
    - master
    changes:
    - .gitlab-ci.yml
    - environments/ci-plan-free-6/**
    - modules/runner-manager-ephemeral-vms-project/**
  <<: *tf_validate

review ci-plan-free-6:
  stage: plan
  dependencies: ["init ci-plan-free-6"]
  environment:
    name: ci-plan-free-6
  needs:
  - init ci-plan-free-6
  - validate ci-plan-free-6
  only:
    refs:
    - merge_requests
    changes:
    - .gitlab-ci.yml
    - environments/ci-plan-free-6/**
    - modules/runner-manager-ephemeral-vms-project/**
  <<: *review_plan

plan ci-plan-free-6:
  stage: plan
  dependencies: ["init ci-plan-free-6"]
  environment:
    name: ci-plan-free-6
  needs:
  - init ci-plan-free-6
  - validate ci-plan-free-6
  only:
    changes:
    - .gitlab-ci.yml
    - environments/ci-plan-free-6/**
    - modules/runner-manager-ephemeral-vms-project/**
    refs:
    - master
  <<: *merge_plan

apply ci-plan-free-6:
  stage: apply
  dependencies:
  - init ci-plan-free-6
  - plan ci-plan-free-6
  environment:
    name: ci-plan-free-6
  needs:
  - init ci-plan-free-6
  - plan ci-plan-free-6
  only:
    refs:
    - master
    changes:
    - .gitlab-ci.yml
    - environments/ci-plan-free-6/**
    - modules/runner-manager-ephemeral-vms-project/**
  when: manual
  <<: *tf_apply

##################################################
# ci-plan-free-7
##################################################
init ci-plan-free-7:
  environment: ci-plan-free-7
  only:
    refs:
      - merge_requests
      - master
    changes:
      - .gitlab-ci.yml
      - environments/ci-plan-free-7/**
      - modules/runner-manager-ephemeral-vms-project/**
  <<: *tf_init

validate ci-plan-free-7:
  dependencies: ["init ci-plan-free-7"]
  environment:
    name: ci-plan-free-7
  needs: ["init ci-plan-free-7"]
  only:
    refs:
      - merge_requests
      - master
    changes:
      - .gitlab-ci.yml
      - environments/ci-plan-free-7/**
      - modules/runner-manager-ephemeral-vms-project/**
  <<: *tf_validate

review ci-plan-free-7:
  stage: plan
  dependencies: ["init ci-plan-free-7"]
  environment:
    name: ci-plan-free-7
  needs:
    - init ci-plan-free-7
    - validate ci-plan-free-7
  only:
    refs:
      - merge_requests
    changes:
      - .gitlab-ci.yml
      - environments/ci-plan-free-7/**
      - modules/runner-manager-ephemeral-vms-project/**
  <<: *review_plan

plan ci-plan-free-7:
  stage: plan
  dependencies: ["init ci-plan-free-7"]
  environment:
    name: ci-plan-free-7
  needs:
    - init ci-plan-free-7
    - validate ci-plan-free-7
  only:
    changes:
      - .gitlab-ci.yml
      - environments/ci-plan-free-7/**
      - modules/runner-manager-ephemeral-vms-project/**
    refs:
      - master
  <<: *merge_plan

apply ci-plan-free-7:
  stage: apply
  dependencies:
    - init ci-plan-free-7
    - plan ci-plan-free-7
  environment:
    name: ci-plan-free-7
  needs:
    - init ci-plan-free-7
    - plan ci-plan-free-7
  only:
    refs:
      - master
    changes:
      - .gitlab-ci.yml
      - environments/ci-plan-free-7/**
      - modules/runner-manager-ephemeral-vms-project/**
  when: manual
  <<: *tf_apply

##################################################
# windows-ci
##################################################
init windows-ci:
  environment: windows-ci
  only:
    refs:
      - merge_requests
      - master
    changes:
      - .gitlab-ci.yml
      - environments/windows-ci/**
  <<: *tf_init

validate windows-ci:
  dependencies: ["init windows-ci"]
  environment:
    name: windows-ci
  needs: ["init windows-ci"]
  only:
    refs:
      - merge_requests
      - master
    changes:
      - .gitlab-ci.yml
      - environments/windows-ci/**
  <<: *tf_validate

review windows-ci:
  stage: plan
  dependencies: ["init windows-ci"]
  environment:
    name: windows-ci
  needs:
    - init windows-ci
    - validate windows-ci
  only:
    refs:
      - merge_requests
    changes:
      - .gitlab-ci.yml
      - environments/windows-ci/**
  <<: *review_plan

plan windows-ci:
  stage: plan
  dependencies: ["init windows-ci"]
  environment:
    name: windows-ci
  needs:
    - init windows-ci
    - validate windows-ci
  only:
    changes:
      - .gitlab-ci.yml
      - environments/windows-ci/**
    refs:
      - master
  <<: *merge_plan

apply windows-ci:
  stage: apply
  dependencies:
    - init windows-ci
    - plan windows-ci
  environment:
    name: windows-ci
  needs:
    - init windows-ci
    - plan windows-ci
  only:
    refs:
      - master
    changes:
      - .gitlab-ci.yml
      - environments/windows-ci/**
  when: manual
  <<: *tf_apply

##################################################
# ci-macos
##################################################
init ci-macos:
  environment: ci-macos
  only:
    refs:
    - merge_requests
    - master
    changes:
    - .ci.yml
    - environments/ci-macos/**
  <<: *tf_init

validate ci-macos:
  dependencies: ["init ci-macos"]
  environment:
    name: ci-macos
  needs: ["init ci-macos"]
  only:
    refs:
    - merge_requests
    - master
    changes:
    - .ci.yml
    - environments/ci-macos/**
  <<: *tf_validate

review ci-macos:
  stage: plan
  dependencies: ["init ci-macos"]
  environment:
    name: ci-macos
  needs:
  - init ci-macos
  - validate ci-macos
  only:
    refs:
    - merge_requests
    changes:
    - .ci.yml
    - environments/ci-macos/**
  <<: *review_plan

plan ci-macos:
  stage: plan
  dependencies: ["init ci-macos"]
  environment:
    name: ci-macos
  needs:
  - init ci-macos
  - validate ci-macos
  only:
    changes:
    - .ci.yml
    - environments/ci-macos/**
    refs:
    - master
  <<: *merge_plan

apply ci-macos:
  stage: apply
  dependencies:
  - init ci-macos
  - plan ci-macos
  environment:
    name: ci-macos
  needs:
  - init ci-macos
  - plan ci-macos
  only:
    refs:
    - master
    changes:
    - .ci.yml
    - environments/ci-macos/**
  when: manual
  <<: *tf_apply

##################################################
# stgsub
##################################################

.stgsub-change-patterns: &stgsub-change-pattern
  - .gitlab-ci.yml
  - environments/stgsub/*
  - environments/stgsub/**/*

init stgsub:
  environment: stgsub
  only:
    refs:
      - merge_requests
      - master
    changes: *stgsub-change-pattern
  <<: *tf_init

validate stgsub:
  dependencies: ["init stgsub"]
  environment:
    name: stgsub
  needs: ["init stgsub"]
  only:
    refs:
      - merge_requests
      - master
    changes: *stgsub-change-pattern
  <<: *tf_validate

review stgsub:
  stage: plan
  dependencies: ["init stgsub"]
  environment:
    name: stgsub
  needs:
    - init stgsub
    - validate stgsub
  only:
    refs:
      - merge_requests
    changes: *stgsub-change-pattern
  <<: *review_plan

plan stgsub:
  stage: plan
  dependencies: ["init stgsub"]
  environment:
    name: stgsub
  needs:
    - init stgsub
    - validate stgsub
  only:
    changes: *stgsub-change-pattern
    refs:
      - master
  <<: *merge_plan

apply stgsub:
  stage: apply
  dependencies:
    - init stgsub
    - plan stgsub
  environment:
    name: stgsub
  needs:
    - init stgsub
    - plan stgsub
  only:
    refs:
      - master
    changes: *stgsub-change-pattern
  when: manual
  <<: *tf_apply

##################################################
# dns
##################################################
init dns:
  environment: dns
  only:
    refs:
      - merge_requests
      - master
    changes:
      - .gitlab-ci.yml
      - environments/dns/*
  <<: *tf_init

validate dns:
  dependencies: ["init dns"]
  environment:
    name: dns
  needs: ["init dns"]
  only:
    refs:
      - merge_requests
      - master
    changes:
      - .gitlab-ci.yml
      - environments/dns/**
  <<: *tf_validate

review dns:
  stage: plan
  dependencies: ["init dns"]
  environment:
    name: dns
  needs:
    - init dns
    - validate dns
  only:
    refs:
      - merge_requests
    changes:
      - .gitlab-ci.yml
      - environments/dns/**
  <<: *review_plan

plan dns:
  stage: plan
  dependencies: ["init dns"]
  environment:
    name: dns
  needs:
    - init dns
    - validate dns
  only:
    changes:
      - .gitlab-ci.yml
      - environments/dns/**
    refs:
      - master
  <<: *merge_plan

apply dns:
  stage: apply
  dependencies:
    - init dns
    - plan dns
  environment:
    name: dns
  needs:
    - init dns
    - plan dns
  only:
    refs:
      - master
    changes:
      - .gitlab-ci.yml
      - environments/dns/**
  when: manual
  <<: *tf_apply

##################################################
# packagecloud
##################################################
init packagecloud:
  environment: packagecloud
  only:
    refs:
      - merge_requests
      - master
    changes:
      - .gitlab-ci.yml
      - environments/packagecloud/*
  <<: *tf_init

validate packagecloud:
  dependencies: ["init packagecloud"]
  environment:
    name: packagecloud
  needs: ["init packagecloud"]
  only:
    refs:
      - merge_requests
      - master
    changes:
      - .gitlab-ci.yml
      - environments/packagecloud/**
  <<: *tf_validate

review packagecloud:
  stage: plan
  dependencies: ["init packagecloud"]
  environment:
    name: packagecloud
  needs:
    - init packagecloud
    - validate packagecloud
  only:
    refs:
      - merge_requests
    changes:
      - .gitlab-ci.yml
      - environments/packagecloud/**
  <<: *review_plan

plan packagecloud:
  stage: plan
  dependencies: ["init packagecloud"]
  environment:
    name: packagecloud
  needs:
    - init packagecloud
    - validate packagecloud
  only:
    changes:
      - .gitlab-ci.yml
      - environments/packagecloud/**
    refs:
      - master
  <<: *merge_plan

apply packagecloud:
  stage: apply
  dependencies:
    - init packagecloud
    - plan packagecloud
  environment:
    name: packagecloud
  needs:
    - init packagecloud
    - plan packagecloud
  only:
    refs:
      - master
    changes:
      - .gitlab-ci.yml
      - environments/packagecloud/**
  when: manual
  <<: *tf_apply

##################################################
# db-benchmarking
##################################################
init db-benchmarking:
  environment: db-benchmarking
  only:
    refs:
      - merge_requests
      - master
    changes:
      - .gitlab-ci.yml
      - environments/db-benchmarking/*
  <<: *tf_init

validate db-benchmarking:
  dependencies: ["init db-benchmarking"]
  environment:
    name: db-benchmarking
  needs: ["init db-benchmarking"]
  only:
    refs:
      - merge_requests
      - master
    changes:
      - .gitlab-ci.yml
      - environments/db-benchmarking/**
  <<: *tf_validate

review db-benchmarking:
  stage: plan
  dependencies: ["init db-benchmarking"]
  environment:
    name: db-benchmarking
  needs:
    - init db-benchmarking
    - validate db-benchmarking
  only:
    refs:
      - merge_requests
    changes:
      - .gitlab-ci.yml
      - environments/db-benchmarking/**
  <<: *review_plan

plan db-benchmarking:
  stage: plan
  dependencies: ["init db-benchmarking"]
  environment:
    name: db-benchmarking
  needs:
    - init db-benchmarking
    - validate db-benchmarking
  only:
    changes:
      - .gitlab-ci.yml
      - environments/db-benchmarking/**
    refs:
      - master
  <<: *merge_plan

apply db-benchmarking:
  stage: apply
  dependencies:
    - init db-benchmarking
    - plan db-benchmarking
  environment:
    name: db-benchmarking
  needs:
    - init db-benchmarking
    - plan db-benchmarking
  only:
    refs:
      - master
    changes:
      - .gitlab-ci.yml
      - environments/db-benchmarking/**
  when: manual
  <<: *tf_apply

##################################################
# db-sharding-poc
##################################################
init db-sharding-poc:
  environment: db-sharding-poc
  only:
    refs:
      - merge_requests
      - master
    changes:
      - .gitlab-ci.yml
      - environments/db-sharding-poc/*
  <<: *tf_init

validate db-sharding-poc:
  dependencies: ["init db-sharding-poc"]
  environment:
    name: db-sharding-poc
  needs: ["init db-sharding-poc"]
  only:
    refs:
      - merge_requests
      - master
    changes:
      - .gitlab-ci.yml
      - environments/db-sharding-poc/**
  <<: *tf_validate

review db-sharding-poc:
  stage: plan
  dependencies: ["init db-sharding-poc"]
  environment:
    name: db-sharding-poc
  needs:
    - init db-sharding-poc
    - validate db-sharding-poc
  only:
    refs:
      - merge_requests
    changes:
      - .gitlab-ci.yml
      - environments/db-sharding-poc/**
  <<: *review_plan

plan db-sharding-poc:
  stage: plan
  dependencies: ["init db-sharding-poc"]
  environment:
    name: db-sharding-poc
  needs:
    - init db-sharding-poc
    - validate db-sharding-poc
  only:
    changes:
      - .gitlab-ci.yml
      - environments/db-sharding-poc/**
    refs:
      - master
  <<: *merge_plan

apply db-sharding-poc:
  stage: apply
  dependencies:
    - init db-sharding-poc
    - plan db-sharding-poc
  environment:
    name: db-sharding-poc
  needs:
    - init db-sharding-poc
    - plan db-sharding-poc
  only:
    refs:
      - master
    changes:
      - .gitlab-ci.yml
      - environments/db-sharding-poc/**
  when: manual
  <<: *tf_apply
